import { declare } from '@babel/helper-plugin-utils';
import { types } from '@babel/core';

var index = declare(api => {
  api.assertVersion("8.0.0-alpha.14");
  function transformStatementList(parentPath, paths) {
    const isInStrictMode = parentPath.isInStrictMode();
    for (const path of paths) {
      if (!path.isFunctionDeclaration()) continue;
      if (!isInStrictMode && !(path.node.async || path.node.generator || path.getData("@babel/plugin-transform-async-generator-functions/async_generator_function"))) {
        continue;
      }
      const func = path.node;
      const declar = types.variableDeclaration("let", [types.variableDeclarator(func.id, types.toExpression(func))]);
      declar._blockHoist = 2;
      func.id = null;
      path.replaceWith(declar);
    }
  }
  return {
    name: "transform-block-scoped-functions",
    visitor: {
      BlockStatement(path) {
        const {
          node,
          parent
        } = path;
        if (types.isFunction(parent, {
          body: node
        }) || types.isExportDeclaration(parent)) {
          return;
        }
        transformStatementList(path, path.get("body"));
      },
      SwitchCase(path) {
        transformStatementList(path, path.get("consequent"));
      }
    }
  };
});

export { index as default };
//# sourceMappingURL=index.js.map
